﻿Module scriptparser
    Private _path As String = ""
    Public Changes As New List(Of Change)
    Public Allow As New List(Of String)
    Private _quote As String = ControlChars.Quote
    Private m As ProcessMemory
    Public Reverse As Boolean = False
    Public Class Change
        Public Name As String = ""
        Public Address As String = ""
        Public Before As String = ""
        Public After As String = ""
    End Class
    Public Function LoadScript(ByVal path As String) As String
        _path = path
        Changes.Clear()
        Dim fs As New IO.FileStream(path, IO.FileMode.Open)
        Dim sr As New IO.StreamReader(fs)
        Dim original As String = ""
        Dim line As String = ""
        Dim mode As Integer = 0
        Dim result As String = ""
        Dim index As Integer = 0
        Dim names As New List(Of String)
        Dim addresses As New List(Of String)
        Dim readline As String = ""
        While Not sr.EndOfStream
            readline = sr.ReadLine
            original = readline.Replace(" ", "").Replace(ControlChars.Tab, "").Split("//")(0)
            index += 1
            line = original.ToLower
            Select Case line
                Case "[name]"
                    If Not ((mode = 0) Or (mode = 4)) Then
                        result += index & ": attribute out of order [name]" & ControlChars.NewLine
                    End If
                    mode = 1
                    Dim entry As New Change
                    Changes.Add(entry)
                Case "[address]"
                    If Not ((mode = 1) Or (mode = 4)) Then
                        result += index & ": attribute out of order [address]" & ControlChars.NewLine
                    End If
                    If mode = 4 Then
                        Dim i As Integer = Changes.Count - 1
                        Dim name = Changes(i).Name
                        Dim entry2 As New Change
                        Changes.Add(entry2)
                        Changes(i).Name = name
                    End If
                    mode = 2
                Case "[before]"
                    If Not mode = 2 Then
                        result += index & ": attribute out of order [before]" & ControlChars.NewLine
                    End If
                    mode = 3
                Case "[after]"
                    If Not mode = 3 Then
                        result += index & ": attribute out of order [after]" & ControlChars.NewLine
                    End If
                    mode = 4
                Case Else
                    Select Case mode
                        Case 1
                            If names.Contains(line) Then
                                result += index & ": duplicate name found " & _quote & original & _quote & ControlChars.NewLine
                            Else
                                names.Add(line)
                                Changes(Changes.Count - 1).Name = readline
                            End If
                        Case 2
                            If addresses.Contains(line) Then
                                result += index & ": duplicate address found [" & original & "]" & ControlChars.NewLine
                            Else
                                addresses.Add(line)
                                Changes(Changes.Count - 1).Address = line
                            End If
                        Case 3
                            Changes(Changes.Count - 1).Before += line
                        Case 4
                            Changes(Changes.Count - 1).After += line
                    End Select
            End Select
        End While
        sr.Close()
        fs.Close()
        Return result
    End Function
    Public Function RunScript(ByVal path As String, ByVal list As List(Of Change)) As String
        Dim fs As New IO.FileStream(path, IO.FileMode.Open)
        Dim bw As New IO.BinaryWriter(fs)
        Dim result As String = ""
        Dim count As Integer = 0
        Dim equal As Boolean = True
        Dim equal2 As Boolean = True
        Dim address As Integer = 0
        Dim lastname As String = ""
        Dim written As Integer = 0
        Dim badbefore As Integer = 0
        Dim already As Integer = 0
        For Each entry In list
            If Not Allow.Contains(entry.Name) Then
                Continue For
            End If
            If Not lastname = entry.Name Then
                result += ControlChars.NewLine & entry.Name & ControlChars.NewLine
                lastname = entry.Name
            End If
            address = CLng("&H" & Clean(entry.Address))
            address -= 1124077568
            address += 4096
            Dim _before As String = ""
            Dim _after As String = ""
            If Reverse Then
                _before = entry.After
                _after = entry.Before
            Else
                _before = entry.Before
                _after = entry.After
            End If
            Dim before As Byte() = HexToData(Clean(_before), _after.Length)
            Dim after As Byte() = HexToData(Clean(_after), _before.Length)
            Dim compare(before.Length - 1) As Byte
            fs.Seek(address, System.IO.SeekOrigin.Begin)
            fs.Read(compare, 0, before.Length)
            equal = True
            equal2 = True
            count = 0
            While count < compare.Length
                If Not before(count) = compare(count) Then
                    If before(count) = 0 Then
                        If Not compare(count) = 144 Then
                            equal = False
                        End If
                    Else
                        equal = False
                    End If
                    Exit While
                End If
                count += 1
            End While
            count = 0
            While count < compare.Length
                If Not after(count) = compare(count) Then
                    If after(count) = 0 Then
                        If Not compare(count) = 144 Then
                            equal2 = False
                        End If
                    Else
                        equal2 = False
                    End If
                    Exit While
                End If
                count += 1
            End While
            If equal2 Then
                result += "[" & entry.Address.ToUpper & "] already applied" & ControlChars.NewLine
                already += 1
            Else
                If equal Then
                    bw.Seek(address, IO.SeekOrigin.Begin)
                    bw.Write(after, 0, after.Length)
                    If Main.written.Checked Then
                        result += "[" & entry.Address.ToUpper & "] written" & ControlChars.NewLine
                    End If
                    written += 1
                Else
                    result += "[" & entry.Address.ToUpper & "] bad before data" & ControlChars.NewLine
                    badbefore += 1
                End If
            End If
        Next
        bw.Flush()
        fs.Flush()
        bw.Close()
        fs.Close()
        While result.StartsWith(ControlChars.NewLine)
            result = result.Remove(0, 1)
        End While
        result += ControlChars.NewLine & written & " written / " & already & " already written / " & badbefore & " bad before"
        Return result
    End Function
    Public Function RunScriptMemory(ByVal pid As Integer, ByVal list As List(Of Change)) As String
        m = New ProcessMemory(Process.GetProcessById(pid), ProcessMemory.ProcessAccess.All)
        m.Open()
        Dim result As String = ""
        Dim count As Integer = 0
        Dim equal As Boolean = True
        Dim equal2 As Boolean = True
        Dim address As Integer = 0
        Dim lastname As String = ""
        Dim written As Integer = 0
        Dim badbefore As Integer = 0
        Dim noaccess As Integer = 0
        Dim already As Integer = 0
        Dim status As Integer = 0
        For Each entry In list
            If Not Allow.Contains(entry.Name) Then
                Continue For
            End If
            If Not lastname = entry.Name Then
                result += ControlChars.NewLine & entry.Name & ControlChars.NewLine
                lastname = entry.Name
            End If
            address = CLng("&H" & Clean(entry.Address))
            Dim _before As String = ""
            Dim _after As String = ""
            If Reverse Then
                _before = entry.After
                _after = entry.Before
            Else
                _before = entry.Before
                _after = entry.After
            End If
            Dim before As Byte() = HexToData(Clean(_before), _after.Length)
            Dim after As Byte() = HexToData(Clean(_after), _before.Length)
            'm.Position = address
            Dim compare As Byte() = m.Read(address, before.Length)
            equal = True
            equal2 = True
            count = 0
            While count < compare.Length
                If Not before(count) = compare(count) Then
                    If before(count) = 0 Then
                        If Not compare(count) = 144 Then
                            equal = False
                        End If
                    Else
                        equal = False
                    End If
                    Exit While
                End If
                count += 1
            End While
            count = 0
            While count < compare.Length
                If Not after(count) = compare(count) Then
                    If after(count) = 0 Then
                        If Not compare(count) = 144 Then
                            equal2 = False
                        End If
                    Else
                        equal2 = False
                    End If
                    Exit While
                End If
                count += 1
            End While
            If equal2 Then
                result += "[" & entry.Address.ToUpper & "] already applied" & ControlChars.NewLine
                already += 1
            Else
                If equal Then
                    ProcessSuspend.SuspendProcess(pid)
                    status = m.Write(address, after)
                    ProcessSuspend.ResumeProcess(pid)
                    If status > 0 Then
                        If Main.written.Checked Then
                            result += "[" & entry.Address.ToUpper & "] written" & ControlChars.NewLine
                        End If
                        written += 1
                    Else
                        result += "[" & entry.Address.ToUpper & "] no access" & ControlChars.NewLine
                        noaccess += 1
                    End If
                Else
                    result += "[" & entry.Address.ToUpper & "] bad before data" & ControlChars.NewLine
                    badbefore += 1
                End If
            End If
        Next
        m.Close()
        While result.StartsWith(ControlChars.NewLine)
            result = result.Remove(0, 1)
        End While
        result += ControlChars.NewLine & written & " written / " & already & " already written / " & badbefore & " bad before / " & noaccess & " no access"
        Return result
    End Function
    Private Function HexToData(ByVal hex As [String], ByVal len As Integer) As Byte()
        hex = hex.ToUpper
        If hex = "NULL" Then
            Return New Byte(len \ 2 - 1) {}
        End If
        Dim NumberChars As Integer = hex.Length
        Dim bytes As Byte() = New Byte(NumberChars \ 2 - 1) {}
        For i As Integer = 0 To NumberChars - 1 Step 2
            bytes(i \ 2) = Convert.ToByte(hex.Substring(i, 2), 16)
        Next
        Return bytes
    End Function
    Private Function Clean(ByVal line As String) As String
        Return line.Replace(" ", "").Replace(ControlChars.Tab, "")
    End Function
End Module
