﻿Imports System.Runtime.InteropServices
Module ProcessSuspend
    <Flags()> _
    Public Enum ThreadAccess As Integer
        TERMINATE = (&H1)
        SUSPEND_RESUME = (&H2)
        GET_CONTEXT = (&H8)
        SET_CONTEXT = (&H10)
        SET_INFORMATION = (&H20)
        QUERY_INFORMATION = (&H40)
        SET_THREAD_TOKEN = (&H80)
        IMPERSONATE = (&H100)
        DIRECT_IMPERSONATION = (&H200)
    End Enum
    <DllImport("kernel32.dll")> _
    Private Function OpenThread(ByVal dwDesiredAccess As ThreadAccess, ByVal bInheritHandle As Boolean, ByVal dwThreadId As UInteger) As IntPtr
    End Function
    <DllImport("kernel32.dll")> _
    Private Function SuspendThread(ByVal hThread As IntPtr) As UInteger
    End Function
    <DllImport("kernel32.dll")> _
    Private Function ResumeThread(ByVal hThread As IntPtr) As Integer
    End Function
    Public Sub SuspendProcess(ByVal PID As Integer)
        Dim proc As Process = Process.GetProcessById(PID)

        If proc.ProcessName = String.Empty Then
            Return
        End If

        For Each pT As ProcessThread In proc.Threads
            Dim pOpenThread As IntPtr = OpenThread(ThreadAccess.SUSPEND_RESUME, False, CUInt(pT.Id))

            If pOpenThread = IntPtr.Zero Then
                Exit For
            End If

            SuspendThread(pOpenThread)
        Next
    End Sub
    Public Sub ResumeProcess(ByVal PID As Integer)
        Dim proc As Process = Process.GetProcessById(PID)

        If proc.ProcessName = String.Empty Then
            Return
        End If

        For Each pT As ProcessThread In proc.Threads
            Dim pOpenThread As IntPtr = OpenThread(ThreadAccess.SUSPEND_RESUME, False, CUInt(pT.Id))

            If pOpenThread = IntPtr.Zero Then
                Exit For
            End If

            ResumeThread(pOpenThread)
        Next
    End Sub
End Module